"""add feeds source_label

Revision ID: 6bf2484780e2
Revises: dfb3d042b1c9
Create Date: 2019-03-25 11:34:06.982164

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
from feed_manager.sql.models import Feed, Classifier

revision = "6bf2484780e2"
down_revision = "dfb3d042b1c9"
branch_labels = None
depends_on = None


def upgrade():
    op.add_column("feeds", sa.Column("source_label", sa.String(), nullable=True))

    # Move all the existing feed source labels from 'classifiers' table to feeds table
    conn = op.get_bind()
    del_stmt = (
        Classifier.__table__.delete()
        .where(Classifier.key.like("%_source_label"))
        .returning(Classifier.key, Classifier.value)
    )

    for result in conn.execute(del_stmt):
        key = result["key"]
        value = result["value"]

        # key will be feed_FEEDID_source_label - pull out the FEEDID
        feed_id = key[5:-13]

        update_stmt = (
            Feed.__table__.update()
            .values({"source_label": value})
            .where(Feed.id == feed_id)
        )
        conn.execute(update_stmt)


def downgrade():  # pragma: no cover
    op.drop_column("feeds", "source_label")
