"""update report severity override fk

Revision ID: 7e817801dc21
Revises: 53873af1d9d9
Create Date: 2018-08-02 08:26:43.839596

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "7e817801dc21"
down_revision = "53873af1d9d9"
branch_labels = None
depends_on = None


def upgrade():
    op.drop_constraint(
        "report_score_overrides_feed_id_fkey",
        "report_severity_overrides",
        type_="foreignkey",
    )
    op.create_foreign_key(
        "report_severity_overrides_report_id_fkey",
        "report_severity_overrides",
        "reports",
        ["report_id", "feed_id"],
        ["id", "feed_id"],
        ondelete="CASCADE",
    )


def downgrade():  # pragma: no cover
    op.drop_constraint(None, "report_severity_overrides", type_="foreignkey")
    op.create_foreign_key(
        "report_score_overrides_feed_id_fkey",
        "report_severity_overrides",
        "feeds",
        ["feed_id"],
        ["id"],
        ondelete="CASCADE",
    )
