"""add subscription constraints

Revision ID: e662f91ce001
Revises: efc4ae8bad9f
Create Date: 2018-06-12 08:56:55.612789

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "e662f91ce001"
down_revision = "efc4ae8bad9f"
branch_labels = None
depends_on = None


def upgrade():
    op.create_unique_constraint(
        "uc_id_version_owner_access", "feeds", ["id", "version", "owner", "access"]
    )

    op.alter_column("subscriptions", "org_key", new_column_name="org_id")
    op.add_column("subscriptions", sa.Column("feed_access", sa.String(), nullable=True))
    op.add_column("subscriptions", sa.Column("feed_owner", sa.String(), nullable=False))
    op.drop_constraint(
        "subscriptions_feed_id_fkey", "subscriptions", type_="foreignkey"
    )
    op.create_foreign_key(
        "subscriptions_feed_id_version_access_owner_fkey",
        "subscriptions",
        "feeds",
        ["feed_id", "feed_version", "feed_access", "feed_owner"],
        ["id", "version", "access", "owner"],
        onupdate="CASCADE",
    )
    op.create_check_constraint(
        "ck_org_or_public",
        "subscriptions",
        "(org_id = feed_owner) or (feed_access = 'public')",
    )


def downgrade():  # pragma: no cover
    op.drop_constraint("ck_org_or_public", "subscriptions", type_="check")
    op.drop_constraint(
        "subscriptions_feed_id_version_access_owner_fkey",
        "subscriptions",
        type_="foreignkey",
    )
    op.create_foreign_key(
        "subscriptions_feed_id_fkey",
        "subscriptions",
        "feeds",
        ["feed_id", "feed_version"],
        ["id", "version"],
    )
    op.drop_column("subscriptions", "feed_owner")
    op.drop_column("subscriptions", "feed_access")
    op.alter_column("subscriptions", "org_id", new_column_name="org_key")

    op.drop_constraint("uc_id_version_owner_access", "feeds", type_="unique")
