"""add report primary keys

Revision ID: efc4ae8bad9f
Revises: a7048a19798c
Create Date: 2018-06-11 21:42:17.447697

"""
from alembic import op


# revision identifiers, used by Alembic.
revision = "efc4ae8bad9f"
down_revision = "a7048a19798c"
branch_labels = None
depends_on = None


def upgrade():
    # CASCADE will delete foreign keys on iocs and iocs_v2
    op.execute("ALTER TABLE reports DROP CONSTRAINT reports_pkey CASCADE")
    op.create_primary_key("reports_pkey", "reports", ["id", "feed_id", "feed_version"])

    op.execute("ALTER TABLE iocs DROP CONSTRAINT iocs_pkey CASCADE")
    op.create_primary_key("iocs_pkey", "iocs", ["report_id", "feed_id", "feed_version"])
    # recreate foreign key
    op.create_foreign_key(
        "iocs_report_id_fkey",
        "iocs",
        "reports",
        ["report_id", "feed_id", "feed_version"],
        ["id", "feed_id", "feed_version"],
    )

    op.execute("ALTER TABLE iocs_v2 DROP CONSTRAINT iocs_v2_pkey CASCADE")
    op.create_primary_key("iocs_v2_pkey", "iocs_v2", ["id", "feed_id", "feed_version"])
    # recreate foreign key
    op.create_foreign_key(
        "iocs_v2_report_id_fkey",
        "iocs_v2",
        "reports",
        ["report_id", "feed_id", "feed_version"],
        ["id", "feed_id", "feed_version"],
    )


def downgrade():  # pragma: no cover
    op.drop_constraint("reports_pkey", "reports", type_="primary")
    op.create_primary_key("reports_pkey", "reports", ["id"])

    op.drop_constraint("iocs_pkey", "iocs", type_="primary")
    op.create_primary_key("iocs_pkey", "iocs", ["report_id"])

    op.drop_constraint("iocs_v2_pkey", "iocs_v2", type_="primary")
    op.create_primary_key("iocs_v2_pkey", "iocs_v2", ["id"])
